# frozen_string_literal: true

class VulnerabilitySummaryEntity < Grape::Entity
  Vulnerabilities::Occurrence::REPORT_TYPES.each do |report_type_name, report_type|
    report_key = Gitlab.rails5? ? report_type_name : report_type
    expose report_type_name do
      Vulnerabilities::Occurrence::LEVELS.each do |severity_name, severity|
        expose severity_name do |group|
          grouped_vulnerabilities[[report_key, severity]] || 0
        end
      end
    end
  end

  private

  def grouped_vulnerabilities
    @grouped_by_report_and_severity ||= object.latest_vulnerabilities.counted_by_report_and_severity
  end
end
